<template>
  <st-content heading="Reportes">
  <!-- PRIMER CAJA -->
    <v-row>
      <v-col>
        <div class="content-body pb-0">
          <st-subtitle text="Seleccionar rango de fechas para generar los distintos reportes presentados a continuación"/>
          <v-row>
            <v-col md="4">
              <div class="table-heading">
                <v-menu
                  ref="menu"
                  v-model="menu"
                  :close-on-content-click="false"
                  :return-value.sync="date"
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on }">
                    <v-text-field v-model="dateRangeText" label="Rango de fechas" readonly v-on="on"></v-text-field>
                  </template>
                  <v-date-picker v-model="date" no-title scrollable range locale="es">
                    <v-spacer></v-spacer>
                    <v-btn text color="primary" @click="menu = false">Cancelar</v-btn>
                    <v-btn text color="primary" @click="cambioFecha">OK</v-btn>
                  </v-date-picker>
                </v-menu>
              </div>
            </v-col>
          </v-row>
        </div>
        </v-col>
    </v-row>
    <v-row>
      <v-col md="4" v-for="(spcard,index) in cards" :key="index">
        <st-sparkline-card 
          :sparkline="spcard.sparkline"
          :card="spcard.card"
          :loading="loading"
          @click="download(index)"
        />
      </v-col>
    </v-row>
  </st-content>
</template>

<script>
import SparklineCard from '@/components/SparklineCard'
export default {
  components:{
    'st-sparkline-card': SparklineCard
  },
  data () {
    return{
      menu: false,
      date: [],
      loading:false,
      cards: [
        {
          sparkline:{ 
            labels: [ '12am', '3am', '6am','9am','12pm','3pm','6pm','9pm'],
            value:[ 410, 200,460,310,675, 250, 240],
            lineWidth: 2,
            type: 'trend'
          },
          card:{
            title: 'Tutorías',
            body: 'Reporte que muestra las tutorías mas solicitadas, así como la satisfaccion del alumno respecto a estas.',
            footer:'reporte basado en el periodo seleccionado',
            color: 'cyan'
          }
        },
        {
          sparkline:{ 
            labels: [ '12am', '3am', '6am','9am','12pm','3pm','6pm','9pm'],
            value:[200, 675, 410, 390, 310, 460, 250, 240],
            lineWidth: 5,
            type: 'bar'
          },
          card:{
            title: 'Tutores',
            body: 'Reporte que muestra la participacion de los tutores de la unidad en las tutorías brindadas.',
            footer:'reporte basado en el periodo seleccionado',
            color: '#E64646'
          }
        },
        {
          sparkline:{ 
            labels: [ '12am', '3am', '6am','9am','12pm','3pm','6pm','9pm'],
            value:[200, 675, 410, 390, 310, 460, 250, 240],
            lineWidth: 2,
            type: 'trend'
          },
          card:{
            title: 'Tutoría al momento',
            body: 'Reporte que muestra la participación de los tutores y los motivos más recurrentes de una tutoría al momento.',
            footer:'reporte basado en el periodo seleccionado',
            color: '#50A554'
          }
        }
      ],
    }
  },
  methods:{
    async loadTutorshipReport(idUnit,ini,fin){
      //this.loading = true
      try{
        let response = await this.$api.getTutorshipReport(idUnit,ini,fin)
        const url = window.URL.createObjectURL(new Blob([response.data]));
        const link = document.createElement('a');
        link.href = url;
        link.setAttribute('download', 'reporte_tutorias.xlsx');
        link.click();
      } catch (e){
        this.$store.commit('setError', e)
      }
        //this.loading = false
    },
    async loadMometTutorshipReport(idUnit,ini,fin){
      //this.loading = true
      try{
        let response = await this.$api.getMometTutorshipReport(idUnit,ini,fin)
        const url = window.URL.createObjectURL(new Blob([response.data]));
        const link = document.createElement('a');
        link.href = url;
        link.setAttribute('download', 'reporte_tutorias_momento.xlsx');
        link.click();
      } catch (e){
        this.$store.commit('setError', e)
      }
      //this.loading = false
    },
    async loadTutorsReport(idUnit,ini,fin){
      //this.loading = true
      try{
        let response = await this.$api.getTutorsReport(idUnit,ini,fin)
        const url = window.URL.createObjectURL(new Blob([response.data]));
        const link = document.createElement('a');
        link.href = url;
        link.setAttribute('download', 'reporte_tutores.xlsx');
        link.click();
      } catch (e){
        this.$store.commit('setError', e)
      }
      //this.loading = false
    },
    download(index){
      const idUnit = this.$store.state.role.idUnit;
      let iniAux = new Date(this.date[0])
      let finAux = new Date(this.date[1])
      iniAux.setHours(iniAux.getHours()+5)
      finAux.setHours(finAux.getHours()+5)
      let ini = iniAux.toISOString()
      let fin = finAux.toISOString()
      switch(index){
        case 0:
          this.loadTutorshipReport(idUnit,ini,fin)
          break
        case 1:
          this.loadTutorsReport(idUnit,ini,fin)
          break
        case 2:
          this.loadMometTutorshipReport(idUnit,ini,fin)
          break
        default:
          console.log('No se está eligiendo bien los valores');
      }
    },
    cambioFecha() {
      this.$refs.menu.save(this.date);
    }, 
    iniDate() {
      let today = new Date();
      let aux = new Date().getTime() +24*60*60*1000;
      let tomorrow = new Date(aux)
      today.setHours(today.getHours()+5)
      tomorrow.setHours(tomorrow.getHours()+5)

      let ini = today.toISOString().substr(0, 10);
      let fin = tomorrow.toISOString().substr(0, 10);
      this.date.push(ini);
      this.date.push(fin);
    }
  },
  computed: {
    dateRangeText() {
      this.date.sort((a, b) => (a > b ? 1 : -1));
      return this.date.join(" ~ ");
    }
  },
  mounted() {
    this.iniDate()
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
